#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using dl = double long;
ll INF = 1e18;
void bfs(vector<vector<ll>> &g, queue<pair<ll,ll>> &q, vector<ll> &dist, vector<ll> &ohr) {
    while (!q.empty()) {
        ll v = q.front().first;
        ll h = q.front().second;
        q.pop();
        for (auto to: g[v]) {
            if (h > 0) {
                dist[to] = dist[v] + 1;
                if (!ohr[to])
                    ohr[to] = 1;
                q.push({to, h-1});
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n, m, k;
    cin >> n >> m >> k;
    vector<vector<ll>> g(n);
    for (ll i = 0; i < m; i++) {
        ll x, y;
        cin >> x >> y;
        x--, y--;
        g[x].push_back(y);
        g[y].push_back(x);
    }
    vector<ll> dist(n, INF), ohr(n);
    queue<pair<ll,ll>> q;
    while (k--) {
        ll x, h;
        cin >> x >> h;
        x--;
        dist[x] = 0;
        ohr[x] = 1;
        q.push({x,h});
    }
    bfs(g, q, dist, ohr);
    vector<ll> ans;
    for (ll i = 0; i < n; i++) {
        if (ohr[i]) {
            ans.push_back(i + 1);
        }
    }
    cout << ans.size() << '\n';
    for (auto i: ans)
        cout << i << " ";
}
