#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using dl = double long;
ll INF = 1e18;

void bfs(vector<vector<ll>> &g, queue<ll> &q, vector<ll> &dist, vector<ll> &ohr, ll &h) {
    while (!q.empty()) {
        ll v = q.front();
        q.pop();
        for (auto to: g[v]) {
            if (dist[to] > dist[v] + 1 && ohr[to] == 0 && dist[v] + 1 <= h) {
                dist[to] = dist[v] + 1;
                ohr[to] = 1;
                q.push(to);
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n, m, k;
    cin >> n >> m >> k;
    vector<vector<ll>> g(n);
    for (ll i = 0; i < m; i++) {
        ll x, y;
        cin >> x >> y;
        x--, y--;
        g[x].push_back(y);
        g[y].push_back(x);
    }
    vector<ll> dist(n, INF), ohr(n);
    queue<ll> q;
    while (k--) {
        ll x, h;
        cin >> x >> h;
        x--;
        dist[x] = 0;
        ohr[x] = 1;
        q.push(x);
        bfs(g, q, dist, ohr, h);
    }
    vector<ll> ans;
    for (ll i = 0; i < n; i++) {
        if (ohr[i]) {
            ans.push_back(i + 1);
        }
    }
    cout << ans.size() << '\n';
    for (auto i: ans)
        cout << i << " ";
}
